RhinoScriptableModel (FreeMarker 2.3.35 API)
Description: declaration: package: freemarker.ext.rhino, class: RhinoScriptableModel

Package freemarker.ext.rhino

# Class RhinoScriptableModel

java.lang.Object
freemarker.ext.rhino.RhinoScriptableModel

All Implemented Interfaces:
  `AdapterTemplateModel`, `TemplateBooleanModel`, `TemplateHashModel`, `TemplateHashModelEx`, `TemplateModel`, `TemplateNumberModel`, `TemplateScalarModel`, `TemplateSequenceModel`

Direct Known Subclasses:
  `RhinoFunctionModel`

public class RhinoScriptableModel extends Object implements TemplateHashModelEx, TemplateSequenceModel, AdapterTemplateModel, TemplateScalarModel, TemplateBooleanModel, TemplateNumberModel

- ## Field Summary

  ### Fields inherited from interface freemarker.template.TemplateBooleanModel

  `FALSE, TRUE`

  ### Fields inherited from interface freemarker.template.TemplateModel

  `NOTHING`

  ### Fields inherited from interface freemarker.template.TemplateScalarModel

  `EMPTY_STRING`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `RhinoScriptableModel​(org.mozilla.javascript.Scriptable scriptable, BeansWrapper wrapper)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `TemplateModel`
  `get​(int index)`
  Retrieves the i-th template model in this sequence.
  `TemplateModel`
  `get​(String key)`
  Gets a `TemplateModel` from the hash.
  `Object`
  `getAdaptedObject​(Class hint)`
  Retrieves the underlying object, or some other object semantically equivalent to its value narrowed by the class hint.
  `boolean`
  `getAsBoolean()`
  `Number`
  `getAsNumber()`
  Returns the numeric value.
  `String`
  `getAsString()`
  Returns the `String` representation of this model.
  `boolean`
  `isEmpty()`
  `TemplateCollectionModel`
  `keys()`
  `int`
  `size()`
  `TemplateCollectionModel`
  `values()`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### RhinoScriptableModel

    public RhinoScriptableModel​(org.mozilla.javascript.Scriptable scriptable, BeansWrapper wrapper)

- ## Method Details

  - ### get

    public TemplateModel get​(String key) throws TemplateModelException
    Description copied from interface: `TemplateHashModel`
    Gets a `TemplateModel` from the hash.
    Specified by:
      `get` in interface `TemplateHashModel`
    Parameters:
      `key` - The name by which the `TemplateModel` is identified in the template.
    Returns:
      The `TemplateModel` referred to by the key, or `null` if not found.
    Throws:
      `TemplateModelException`

  - ### get

    public TemplateModel get​(int index) throws TemplateModelException
    Description copied from interface: `TemplateSequenceModel`
    Retrieves the i-th template model in this sequence.
    Specified by:
      `get` in interface `TemplateSequenceModel`
    Returns:
      the item at the specified index, or `null` if the index is out of bounds. Note that a `null` value is interpreted by FreeMarker as "variable does not exist", and accessing a missing variables is usually considered as an error in the FreeMarker Template Language, so the usage of a bad index will not remain hidden, unless the default value for that case was also specified in the template.
    Throws:
      `TemplateModelException`

  - ### isEmpty

    public boolean isEmpty()
    Specified by:
      `isEmpty` in interface `TemplateHashModel`

  - ### keys

    public TemplateCollectionModel keys() throws TemplateModelException
    Specified by:
      `keys` in interface `TemplateHashModelEx`
    Returns:
      a collection containing the keys in the hash. Every element of the returned collection must implement the `TemplateScalarModel` (as the keys of hashes are always strings).
    Throws:
      `TemplateModelException`

  - ### size

    public int size()
    Specified by:
      `size` in interface `TemplateHashModelEx`
    Specified by:
      `size` in interface `TemplateSequenceModel`
    Returns:
      the number of key/value mappings in the hash.

  - ### values

    public TemplateCollectionModel values() throws TemplateModelException
    Specified by:
      `values` in interface `TemplateHashModelEx`
    Returns:
      a collection containing the values in the hash. The elements of the returned collection can be any kind of `TemplateModel`-s.
    Throws:
      `TemplateModelException`

  - ### getAsBoolean

    public boolean getAsBoolean()
    Specified by:
      `getAsBoolean` in interface `TemplateBooleanModel`
    Returns:
      whether to interpret this object as true or false in a boolean context

  - ### getAsNumber

    public Number getAsNumber()
    Description copied from interface: `TemplateNumberModel`
    Returns the numeric value. The return value must not be `null`.
    Specified by:
      `getAsNumber` in interface `TemplateNumberModel`
    Returns:
      the `Number` instance associated with this number model.

  - ### getAsString

    public String getAsString()
    Description copied from interface: `TemplateScalarModel`
    Returns the `String` representation of this model. Returning `null` is illegal, and may cause exception in the calling code. (Except, in classic-compatible mode the engine will convert `null` into empty string.)
    Specified by:
      `getAsString` in interface `TemplateScalarModel`

  - ### getAdaptedObject

    public Object getAdaptedObject​(Class hint)
    Description copied from interface: `AdapterTemplateModel`
    Retrieves the underlying object, or some other object semantically equivalent to its value narrowed by the class hint.
    Specified by:
      `getAdaptedObject` in interface `AdapterTemplateModel`
    Parameters:
      `hint` - the desired class of the returned value. An implementation should make reasonable effort to retrieve an object of the requested class, but if that is impossible, it must at least return the underlying object as-is. As a minimal requirement, an implementation must always return the exact underlying object when `hint.isInstance(underlyingObject)` holds. When called with `java.lang.Object.class`, it should return a generic Java object (i.e. if the model is wrapping a scripting language object that is further wrapping a Java object, the deepest underlying Java object should be returned).
    Returns:
      the underlying object, or its value accommodated for the hint class.